<?php

// Comment this out if you have curl compiled static into php4
dl('curl.so');

/*
  $Id: ctriv.php upgrade,v 1.0 2008/10/19 21:04:15 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

function ctriv_posttohost($url, $data) {

  $encoded = "";
  if (is_array($data)) {
    while (list($k,$v) = each($data)) {
      $encoded .= ($encoded ? "&" : "");
      $encoded .= rawurlencode($k)."=".rawurlencode($v);
    }
  }
  else {
    $encoded = $data;
  }

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$url);  
  curl_setopt($ch, CURLOPT_FAILONERROR, 1);
  curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
  curl_setopt($ch, CURLOPT_TIMEOUT, 3); //times out after 4s
  curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $encoded);
  $results=curl_exec ($ch);
  curl_close ($ch);

  return $results;
}

  class ctriv {
    var $code, $title, $description, $enabled;

// class constructor
    function ctriv() {
      global $order;

      $this->code = 'ctriv';
      $this->title = MODULE_PAYMENT_CTRIV_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_CTRIV_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_CTRIV_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_CTRIV_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_CTRIV_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_CTRIV_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();


    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_CTRIV_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_CTRIV_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      global $order, $currencies, $currency;

      if (MODULE_PAYMENT_CTRIV_CURRENCY == 'Selected Currency') {
        $my_currency = $currency;
      } else {
        $my_currency = substr(MODULE_PAYMENT_CTRIV_CURRENCY, 5);
      }
      if (!in_array($my_currency, array('CAD', 'EUR', 'GBP', 'JPY', 'USD'))) {
        $my_currency = 'USD';
      }

      $data = array (
      'id'=>MODULE_PAYMENT_CTRIV_ID,
      'password'=>MODULE_PAYMENT_CTRIV_PASSWORD,
      'action'=>MODULE_PAYMENT_CTRIV_ACTION,
//      'amt'=>number_format(($order->info['total'] - $order->info['shipping_cost']) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency)),
      'amt'=>number_format($order->info['total'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency)),
      'currencycode'=>'978',
      'langid'=>'USA',
      'responseURL'=>tep_href_link('ctriv_receipt.php', '', 'SSL'),
      'errorURL'=>tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL', false),
      'trackid'=>date('Ymdhis'),
      'udf1'=>'AA',
      'udf2'=>'BB',
      'udf3'=>'CC',
      'udf4'=>'DD',
      'udf5'=>'EE');

      switch (MODULE_PAYMENT_CTRIV_MODE) {
        case 'Test':
          $ctriv_mode = 'http://test4.constriv.com/cg301/servlet/PaymentInitHTTPServlet';
          break;
        case 'Produzione':
          $ctriv_mode = 'https://www.constriv.com/cg/servlet/PaymentInitHTTPServlet';
          break;
        default:
          $ctriv_mode = 'http://test4.constriv.com/cg301/servlet/PaymentInitHTTPServlet';
          break;
      }

      $fcontents = ctriv_posttohost($ctriv_mode,$data);

      $payment_array=explode (":",$fcontents);
//    pid = mid(stringa,1,16)
//    url = mid(stringa,18,(len(stringa)-17))

      $this->form_action_url = $payment_array[1] . ':' . $payment_array[2] . '?PaymentID=' . $payment_array[0];

      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      return false;
    }

    function before_process() {
      global $_POST, $_GET;

      if (isset($_GET[PaymentID]) && isset($_GET[TransID]) && 
          isset($_GET[resultcode]) && isset($_GET[auth]) && 
	  isset($_GET[postdate]) && isset($_GET[TrackID])) {
        $before_process_string = "Payment ID: ".$_GET[PaymentID]."<br>".
				 "Transaction ID: ".$_GET[TransID]."<br>".
        			 "Result Code: ".$_GET[resultcode]."<br>".
        			 "Auth Code: ".$_GET[auth]."<br>".
        			 "Post Date: ".$_GET[postdate]."<br>".
        			 "Track ID: ".$_GET[TrackID]."<br>".
        			 "Reference ID: ".$_GET[ref]."<br>".
        			 "udf1: ".$_GET[udf1]."<br>".
        			 "udf2: ".$_GET[udf2]."<br>".
        			 "udf3: ".$_GET[udf3]."<br>".
        			 "udf4: ".$_GET[udf4]."<br>".
				 "udf5: ".$_GET[udf5]."<br>";
          if ($_GET[resultcode] == 'CAPTURED' ||
              $_GET[resultcode] == 'APPROVED') {
	      return;
	  }
      }
      
      $error_message = 'PaymentID: '.$_GET['PaymentID'].' - '.
		       'Error: '.$_GET['Error'].' - '.
		       'ErrorText: '.$_GET['ErrorText'];
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, tep_session_name() . '=' . $_POST[tep_session_name()] . '&payment_error=' . $this->code . '&message=' . $error_message, 'SSL', false, false));
      return $before_process_string;
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $_GET;
                                                                                
      if (isset($_GET['message']) && (strlen($_GET['message']) > 0)) {
        $error = stripslashes(urldecode($_GET['message']));
      } else {
        $error = MODULE_PAYMENT_CTRIV_TEXT_ERROR_MESSAGE;
      }
                                                                                
      return array('title' => MODULE_PAYMENT_CTRIV_TEXT_ERROR,
                   'error' => $error);
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_CTRIV_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_CTRIV_CURRENCY', 'Selected Currency', 'The currency to use for credit card transactions', '6', '0', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only CAD\',\'Only EUR\',\'Only GBP\',\'Only JPY\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_CTRIV_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '1', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_CTRIV_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '2', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_CTRIV_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '3', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Payment Gateway Consorzio Triveneto Module', 'MODULE_PAYMENT_CTRIV_STATUS', 'True', 'Do you want to accept Payment Gateway Consorzio Triveneto payments?', '6', '4', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID', 'MODULE_PAYMENT_CTRIV_ID', '00000000', 'The ID to use for the Payment Gateway Consorzio Triveneto service', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PASSWORD', 'MODULE_PAYMENT_CTRIV_PASSWORD', 'password', 'The Password to use for the Payment Gateway Consorzio Triveneto service', '6', '6', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_CTRIV_MODE', 'Test', 'The Mode to use for credit card transactions', '6', '7', 'tep_cfg_select_option(array(\'Test\',\'Produzione\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ACTION', 'MODULE_PAYMENT_CTRIV_ACTION', '4', 'The Action to use for the Payment Gateway Consorzio Triveneto service', '6', '8', 'tep_cfg_select_option(array(\'1\',\'4\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Language', 'MODULE_PAYMENT_CTRIV_LANGUAGE', 'USA', 'The language to use for credit card transactions', '6', '9', 'tep_cfg_select_option(array(\'ITA\',\'USA\',\'FRA\',\'DEU\',\'ESP\'), ', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_CTRIV_STATUS', 'MODULE_PAYMENT_CTRIV_ID', 'MODULE_PAYMENT_CTRIV_PASSWORD', 'MODULE_PAYMENT_CTRIV_CURRENCY', 'MODULE_PAYMENT_CTRIV_MODE', 'MODULE_PAYMENT_CTRIV_ACTION', 'MODULE_PAYMENT_CTRIV_LANGUAGE', 'MODULE_PAYMENT_CTRIV_ZONE', 'MODULE_PAYMENT_CTRIV_ORDER_STATUS_ID', 'MODULE_PAYMENT_CTRIV_SORT_ORDER');
    }
  }
?>
