<?php
/*
  $Id: telepaylight.php,v 0.01 2003/11/28 12:45:15 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

/* 

Ambiente di test:	http://telepaytest.ssb.net/tltest/index.html
Ambiente di produzione:	https://secure.ssb.net/tl/index.html

*/

  class telepaylight {
    var $code, $title, $description, $enabled;

// class constructor
    function telepaylight() {
      global $order;

      $this->code = 'telepaylight';
      $this->title = MODULE_PAYMENT_TELEPAYLIGHT_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_TELEPAYLIGHT_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_TELEPAYLIGHT_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_TELEPAYLIGHT_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_TELEPAYLIGHT_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_TELEPAYLIGHT_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      switch (MODULE_PAYMENT_TELEPAYLIGHT_MODE) {
        case 'Test':
          $telepaylight_mode = 'http://telepaytest.ssb.net/tltest/index.html';
          break;
        case 'Produzione':
          $telepaylight_mode = 'https://secure.ssb.net/tl/index.html';
          break;
        default:
          $telepaylight_mode = 'http://telepaytest.ssb.net/tltest/index.html';
          break;
      }
      $this->form_action_url = $telepaylight_mode;
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_TELEPAYLIGHT_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_TELEPAYLIGHT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies, $currency;
                                                                                                                            
      if (MODULE_PAYMENT_TELEPAYLIGHT_CURRENCY == 'Selected Currency') {
        $my_currency = $currency;
      } else {
        $my_currency = substr(MODULE_PAYMENT_TELEPAYLIGHT_CURRENCY, 5);
      }
      if (!in_array($my_currency, array('CAD', 'EUR', 'GBP', 'JPY', 'USD'))) {
        $my_currency = 'USD';
      }

      switch (MODULE_PAYMENT_TELEPAYLIGHT_CARD) {
        case 'Visa':
          $telepaylight_card = '01';
          break;
        case 'Mastercard':
          $telepaylight_card = '02';
          break;
        case 'Amex':
          $telepaylight_card = '06';
          break;
        case 'Diners':
          $telepaylight_card = '07';
          break;
        case 'Carta Facile':
          $telepaylight_card = '10';
          break;
        case 'Selected Card':
        default:
          $telepaylight_card = '';
          break;
      }


//      $process_button_string = tep_draw_hidden_field('IMPORTO', number_format(($order->info['total'] - $order->info['shipping_cost']) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency))) .
      $process_button_string = tep_draw_hidden_field('IMPORTO', number_format(($order->info['total'] ) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency)) * 100) .
                               tep_draw_hidden_field('VALUTA', '978').
//                               tep_draw_hidden_field('NUMORD', STORE_NAME.date('Ymdhis')).
                               tep_draw_hidden_field('NUMORD', STORE_NAME. $order->customer['firstname'].'-'.$order->customer['lastname'].'-'.date('Ymdhis')).
                               tep_draw_hidden_field('EMAIL', $order->customer['email_address']).
                               tep_draw_hidden_field('MID', MODULE_PAYMENT_TELEPAYLIGHT_MID).
                               tep_draw_hidden_field('CARD', $telepaylight_card).
                               tep_draw_hidden_field('LINGUA', MODULE_PAYMENT_TELEPAYLIGHT_LANGUAGE).
                               tep_draw_hidden_field('URLDONE', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')).
                               tep_draw_hidden_field('URLBACK', tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL', false)).
                               tep_draw_hidden_field('URLMS', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'));

      return $process_button_string;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;
                                                                                
      if (isset($HTTP_GET_VARS['message']) && (strlen($HTTP_GET_VARS['message']) > 0)) {
        $error = stripslashes(urldecode($HTTP_GET_VARS['message']));
      } else {
        $error = MODULE_PAYMENT_TELEPAYLIGHT_TEXT_ERROR_MESSAGE;
      }
                                                                                
      return array('title' => MODULE_PAYMENT_TELEPAYLIGHT_TEXT_ERROR,
                   'error' => $error);
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_TELEPAYLIGHT_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_TELEPAYLIGHT_CURRENCY', 'Selected Currency', 'The currency to use for credit card transactions', '6', '6', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only CAD\',\'Only EUR\',\'Only GBP\',\'Only JPY\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_TELEPAYLIGHT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_TELEPAYLIGHT_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_TELEPAYLIGHT_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Payment Gateway SSB SSB TELEpay Light Module', 'MODULE_PAYMENT_TELEPAYLIGHT_STATUS', 'True', 'Do you want to accept Payment Gateway SSB TELEpay Light payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID', 'MODULE_PAYMENT_TELEPAYLIGHT_MID', '00000000000', 'The ID to use for the Payment Gateway SSB TELEpay Light service', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_TELEPAYLIGHT_MODE', 'Test', 'The Mode to use for credit card transactions', '6', '5', 'tep_cfg_select_option(array(\'Test\',\'Produzione\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Card', 'MODULE_PAYMENT_TELEPAYLIGHT_CARD', 'Selected Card', 'The credit card to use for credit card transactions', '6', '6', 'tep_cfg_select_option(array(\'Selected Card\',\'Visa\',\'Mastercard\',\'Amex\',\'Diners\',\'Carta Facile\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Language', 'MODULE_PAYMENT_TELEPAYLIGHT_LANGUAGE', 'ITA', 'The language to use for credit card transactions', '6', '7', 'tep_cfg_select_option(array(\'ITA\',\'USA\',\'FRA\',\'DEU\',\'ESP\'), ', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_TELEPAYLIGHT_STATUS', 'MODULE_PAYMENT_TELEPAYLIGHT_MID', 'MODULE_PAYMENT_TELEPAYLIGHT_CURRENCY', 'MODULE_PAYMENT_TELEPAYLIGHT_MODE', 'MODULE_PAYMENT_TELEPAYLIGHT_LANGUAGE', 'MODULE_PAYMENT_TELEPAYLIGHT_CARD', 'MODULE_PAYMENT_TELEPAYLIGHT_ZONE', 'MODULE_PAYMENT_TELEPAYLIGHT_ORDER_STATUS_ID', 'MODULE_PAYMENT_TELEPAYLIGHT_SORT_ORDER');
    }
  }
?>
